/*  Renderman shadeop to bake the front scatter UVs  */


#include <iostream>
#include <vector>
#include "shadeop.h"


using std::vector;

class dumpingScatterData {

public :

	void setpath( char * _filename ){ filename = _filename; }
	void addpoint( float *uu, float *vv, float *piu, float *piv );
	virtual	~dumpingScatterData ();

private :

	char *filename;
	vector<float>uArray;
	vector<float>vArray;
	vector<float>piuArray;
	vector<float>pivArray;
	void writedata();
	
};

// class destructor - call the function to write the data
dumpingScatterData::~dumpingScatterData ()
{
	writedata();
}


// write the buffer to file
void dumpingScatterData::writedata()
{
	
	FILE *fp;

	fp = fopen( filename, "w");
	
	int i;
	for( i = 0; i < uArray.size(); i ++ )
		fprintf(fp, "u %f v %f piu %f piv %f\n", uArray[i], vArray[i], piuArray[i], pivArray[i]);
		
	fclose(fp);
	
}


void dumpingScatterData::addpoint( float *uv, float *vv, float *ppiu, float *ppiv )
{
	uArray.push_back( *uv );
	vArray.push_back( *vv );
	piuArray.push_back( *ppiu );
	pivArray.push_back( *ppiv );

}



/********************************************************/

extern "C"
{

SHADEOP_TABLE(bakeFrontScatter) = 
{
	{ "float bakeFrontScatter_f ( float, float, float, float)", "init", "cleanup"},
	{ "" }
};

SHADEOP_INIT(init);
SHADEOP(bakeFrontScatter_f);
SHADEOP_CLEANUP(cleanup);
};

SHADEOP_INIT(init)
{
		dumpingScatterData *data = new dumpingScatterData;
		return data;
}

SHADEOP_CLEANUP(cleanup)
{
	dumpingScatterData *dsd = (dumpingScatterData *) initdata;	
	delete dsd;
}

SHADEOP(bakeFrontScatter_f)
{

	float *u = (float *)argv[1];
	float *v = (float *)argv[2];
	float *Piu = (float *)argv[3];
	float *Piv = (float *)argv[4];

	dumpingScatterData *dsd = (dumpingScatterData *) initdata;
	dsd->setpath("scatter.bk");
	dsd->addpoint(u, v, Piu, Piv);

	return 0;
}




	
///:~
