/************************************************************************ 
	Renderman shadeop to bake the the uv coordinate at each point P
***********************************************************************/

#include <iostream>
#include <vector>
#include "shadeop.h"


using std::vector;
// declare the function class for data buffering and disk accessing
//
class dumpingData {

public :

	void setpath( char * _filename ){ filename = _filename; }
	void addpoint( float *uv, float *vv, float *pt );
	virtual	~dumpingData ();

private :

	char *filename;
	vector<float>uArray;
	vector<float>vArray;
	vector<float>ptArray;
	void writedata();
	
};

// class destructor - call the function to write the data
//
dumpingData::~dumpingData ()
{
	writedata();
}

// write the buffer to file
//
void dumpingData::writedata()
{
	
	FILE *fp;

	fp = fopen( filename, "w");
	
	int i;
	for( i = 0; i < uArray.size(); i ++ )
		fprintf(fp, "v %f %f %f %f %f\n", uArray[i], vArray[i], ptArray[i * 3], ptArray[i * 3 + 1], ptArray[i * 3 + 2] );
		
	fclose(fp);
	
}

// append data here
//
void dumpingData::addpoint( float *uv, float *vv, float *pt )
{
	uArray.push_back( *uv );
	vArray.push_back( *vv );
	ptArray.push_back( pt[0] );
	ptArray.push_back( pt[1] );
	ptArray.push_back( pt[2] );

}

// declare the DSO Shadeop in "C"
//
extern "C"
{
SHADEOP_TABLE(bakePointUV) =
{
    { "void bakePointUV_f (point, color, float, float)", "dumpData_init", "dumpData_done" },
    { "" }
};

SHADEOP_INIT(dumpData_init);
SHADEOP_CLEANUP(dumpData_done);
SHADEOP(bakePointUV_f);

};

// initialization function
// build and return the data block
//
//void *dumpData_init ( int , void * )
SHADEOP_INIT(dumpData_init)
{
	dumpingData *data = new dumpingData;
	return data;
}

// shutdown function called after rendering is complete
// destroy the data block
//
//void dumpData_done ( void *data )
SHADEOP_CLEANUP(dumpData_done)
{
	dumpingData *db = ( dumpingData *) initdata;
	delete db;
}

// actual implementation of the shadeop
// take the arguments and call the routines
//
//int dumpData_f ( void *data, int nargs, void **argv )
SHADEOP(dumpData_f)
{

// take the arguments, ignore the color input
//
	float *p = (float *)argv[1];
	float *u = (float *)argv[3];
	float *v = (float *)argv[4];
	
	dumpingData *db = ( dumpingData *) initdata;
	db->setpath( "grids.out" );
	db->addpoint( u, v, p );

	return 0;
}

///:~
