/* ************************************************************************
	 Bake back scatter contribution
	
*****************************************************************************/





//calculate back scattering
color backScatter(point Pin; normal Nnin; float Ksub, extcoeff, samples)
{
       
 
	color backScatterCol=0;	
	
        color raycolor = 0, sum = 0, irrad;
        float dist = 0;
        

            /* Add subsurface scattering */
            if (Ksub > 0) {
                gather("illuminance", Pin, -Nnin, PI/4, samples,
                       "label", "subsurface",
                       "surface:Ci", raycolor, "ray:length", dist) {
                    sum += exp(-extcoeff*dist) * raycolor;
                }
                irrad = sum / samples;
                backScatterCol += Ksub * irrad;
            }
        
       return backScatterCol;
       
}


surface bake_backScatter_contribution (
		string filename = "";
		float extcoeff = 0.227;
		float samples = 16;
		)
{
	normal Nn = normalize(N);
	normal Nf = faceforward(normalize(N), I);
	
	string raylabel;
	rayinfo("label", raylabel);

	color Cout = 0;
	color opacity = Os;
	
	//check to see if invoked by ray we just sent
	if(raylabel == "subsurface")
	{
		Cout = diffuse(Nn);
	}
	else
	{
		color backScatterColor = 0;
		
		backScatterColor = backScatter(P, N, 1, extcoeff, samples);
			
		Cout = backScatterColor;
		
		//bake
		if(filename != "")
			irradiancecache("insert", filename, "w", P, Nn, "irradiance", backScatterColor);
		
		opacity = 0.5;
	}
	
	Oi = Os;
	Ci = Cout;
}